
cur_players = 0

function GetRequiredVersion()
	return 10057
end

function OnScriptLoad(processid)

end

function OnScriptUnload()
	registertimer(500, "checkIfGameStart")
end

function checkIfGameStart(id, count)
	if not game_started then
		GameStart(true)
	end
	return 0
end

function OnNewGame(map)
	game_started = true
	GameStart(false)
end

function GameStart(reloaded)
	game = GetGameAddresses()
	writedword(update_time, 0x0, 300)
	vchanger = registertimer(300, "versionChanger")
end

GetGameAddresses = function()
	local map_header_version = readbyte(0x630e74, 0x4)
	if map_header_version == 7 then
		ctf_globals = 0x639B98 -- Confirmed.
		oddball_globals = 0x639E18 -- Confirmed.
		slayer_globals = 0x63A0E8
		name_base = 0x745D4A
		specs_addr = 0x662D04
		map_addr = 0x698F21
		hashcheck_addr = 0x59c280
		versioncheck_addr = 0x5152E7
		map_pointer = 0x63525c
		gametype_base = 0x671340
		gametime_base = 0x671420
		machine_pointer = 0x745BA0
		version_address = 0x5DF840
		timelimit_address = 0x626630
		profilepath = 0x6A0A99
		special_chars = 0x517D6B -- special chars in svname patch
		gametype_patch = 0x481F3C -- gametype patch
		devmode_patch1 = 0x4A4DBF -- devmode
		devmode_patch2 = 0x4A4E7F -- devmode
		update_time = 0x5992DE
		return "PC"
	else
		ctf_globals = 0x5BDBB8 -- Confirmed.
		oddball_globals = 0x5BDE78 -- Confirmed.
		slayer_globals = 0x5BE108
		name_base = 0x6C7B6A
		specs_addr = 0x5E6E63
		map_addr = 0x61D151
		hashcheck_addr = 0x530130
		versioncheck_addr = 0x4CB587
		map_pointer = 0x5B927C
		gametype_base = 0x5F5498
		gametime_base = 0x5F55BC
		machine_pointer = 0x6C7980
		version_address = 0x564B34
		gametype_patch = 0x45E50C
		devmode_patch1 = 0x47DF0C
		devmode_patch2 = 0x47DFBC -- devmode
		update_time = 0x52DB7E
		return "CE"
	end
end

function versionChanger(id, count)
	if count % 3 == 0 then
		--svcmd("sv_name \"~ ZOMBIES - HaloPCServers.com\"")
	elseif count % 3 == 1 then
		--svcmd("sv_name \"! ZOMBIES - HaloPCServers.com\"")
	elseif count % 3 == 2 then
		--svcmd("sv_name \"ZOMBIES - HaloPCServers.com\"")
	end
	return 1
end

function OnGameEnd(mode)
	if mode == 1 then
		removetimer(vchanger)
	end
end

function OnServerChat(player, mode, message)
	return 1
end

function OnServerCommand(player, command)
	return 1
end

function OnTeamDecision(team)
	return team
end

function OnPlayerJoin(player, team)
	cur_players = cur_players + 1
end

function OnPlayerLeave(player, team)
	cur_players = cur_players - 1
end

function OnPlayerKill(killer, victim, mode)

end

function OnKillMultiplier(player, multiplier)

end

function OnPlayerSpawn(player, m_objectId)

end

function OnPlayerSpawnEnd(player, m_objectId)

end

function OnTeamChange(relevant, player, team, change)
	return 1
end

function OnClientUpdate(player, m_objectId)

end

function OnObjectInteraction(player, m_objectId, tagtype, tagname)
	return 1
end

function OnWeaponReload(player, weapon)
	return 1
end

function OnVehicleEntry(relevant, player, vehicle, tagname, seat)
	return 1
end

function OnVehicleEject(player, forced)
	return 1
end

function OnDamageLookup(receiving_obj, causing_obj, tagdata, tagname)

end

function OnWeaponAssignment(player, m_objectId, count, tagname)
	return 0
end

function OnObjectCreation(m_objectId, owner, tagname)
	
end

writestring = function(string, address, offset, spacing, endian)

	local char_table = {}

	offset = offset or 0x0

	address = address + offset

	spacing = spacing or 0x1

	for word in string:gmatch(".") do
		table.insert(char_table, string.byte(word))
	end

	local length = table.getn(char_table)

	if endian == 1 then
		for i=0,length do
			writebyte(address, spacing * i, char_table[length - i])
		end
	else
		for i=0,length do
			writebyte(address, spacing * i, char_table[i + 1])
		end
	end
end
